/*******************************************************************************/
/*   Program Name  : 8seglcdcont.h
/*   Disctiption   : 8Segment LCDwb_[
/*   History       : Ver@1.00@@2009/06/05
/*
/*   Program       : garbagecollection (Alpha8)
/*
/*******************************************************************************/

#include	<2144s.h>
/*******************************************************************************/
/*   Function Name : Define Port                           					   *
/*   Disctiption   : o̓|[gݒ                          				   *
/*   Input         :                            							   *
/*   Output        : LCD INPORT/OUTPUT PORT SETTINGS                           *
/*					7   6   5   4   3   2   1   0                              */
/*				   PB7 PB6 PB5 PB5 PB3 PB2 PB1 PB0                             */
/*													                           */
/*				   CS1 CS2  RW  E   DI RST									   */
/*				   P47 P83 P45 P46 P43 P60 P-- P--                             */
/*				                                                               */
/*******************************************************************************/
#define LCDD_PORT	PB.ODR.BYTE
#define LCDD_PORTD	PB.DDR

#define LCD6_PORT	P6.DR.BYTE
#define LCD6_PORTD	P6.DDR

#define	SLCD_RST	P6.DR.BIT.B0
#define	SLCD_CLK	P6.DR.BIT.B1
#define	SLCD_DAT	P6.DR.BIT.B2
#define	SLCD_INT	P6.DR.BIT.B3
#define	SLCD_BLT	P6.DR.BIT.B6
/******************************************************************************
 *  ϐ`
 ******************************************************************************/

// 8SEG LCD \pobt@
static  unsigned char   LCDBUF_02[18] ; 						// ҏWpobt@

static unsigned char segdat[] = {0x7D,0x05,0x5E,0x4F,0x27,0x6b,0x7b,0x45,
	                               0x7F,0x6F,0x77,0x3B,0x1A,0x1F,0x7A,0x72};
									

/*******************************************************************************/
/*   Function Name : Prototype declaration
/*   Disctiption   : vg^Cv錾
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_cls(void);
void lcd8_BLT(unsigned int);
void lcd8_int(void);
void lcd8_write(char);
void lcd8_cmdwrt(char);
void lcd8_clk(void);
void lcd8_init(void);
void lcd8_BLT(unsigned int);
void lcd8_put(unsigned int,unsigned int,unsigned int);
void lcd8_init_old(void);
/*******************************************************************************/
/*   Function Name : void lcd8_BLT(unsigned int C)
/*   Disctiption   : 8Seg LCD BackRight ON:1/OFF:0
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_BLT(unsigned int C)
{
	if ( C=1) SLCD_BLT=1;
	else SLCD_BLT=0;
}

/*******************************************************************************/
/*   Function Name : lcd8_write(char data)
/*   Disctiption   : 8Seg LCD Data Write 
/*   Input         : send data
/*   Output        : 
/*******************************************************************************/
void lcd8_write(char data)
{
	int i;
	for (i=0; i<8; i++)
	{
		SLCD_DAT=((data >> 7)& 0x01);

		lcd8_clk();
		
		data=data << 1;
	}
	SLCD_DAT=0;
	for (i=0; i<600; i++);		// 40usȏɂȂ悤 
}
/*******************************************************************************/
/*   Function Name : lcd8_cmdwrt(char data)
/*   Disctiption   : 8Seg LCD Command Data Write 
/*   Input         : send data
/*   Output        : 
/*******************************************************************************/
void lcd8_cmdwrt(char data)
{
	int i;
	for (i=0; i<4; i++)
	{
		SLCD_DAT=((data >> 3)& 0x01);

		lcd8_clk();
		
		data=data << 1;
	}
//	SLCD_DAT=0;
//	for (i=0; i<600; i++);		// 40usȏɂȂ悤 
}
/*******************************************************************************/
/*   Function Name : lcd8_clk(void)
/*   Disctiption   : 8Seg LCD CLK1pX 
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_clk(void)
{
	int i;
	SLCD_CLK=1;
	for (i=0; i<10; i++);	// 1usȏɂȂ悤
	SLCD_CLK=0;
	for (i=0; i<10; i++);	// 1usȏKv
}
/*******************************************************************************/
/*   Function Name : lcd8_int(void)
/*   Disctiption   : 8Seg LCD INT1pX 
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_int(void)
{
	unsigned int i;
	SLCD_INT=1;
	for (i=0; i<1300; i++);		// 200usȏɂȂ悤ɒ
	SLCD_INT=0;
	for (i=0; i<1000; i++);
}
/*******************************************************************************/
/*   Function Name : lcd8_init(void)
/*   Disctiption   : 8Seg LCD CjVCY 
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_init(void)
{
	SLCD_RST=0;
	lcd8_int();
	lcd8_int();
	lcd8_cmdwrt(0x08);
	lcd8_cmdwrt(0x00);
	lcd8_cmdwrt(0x03);
	lcd8_int();
	lcd8_int();
	lcd8_cmdwrt(0x08);
	lcd8_cmdwrt(0x00);
	lcd8_cmdwrt(0x03);
	lcd8_int();
	lcd8_int();
	lcd8_cmdwrt(0x08);
	lcd8_cmdwrt(0x00);
	lcd8_cmdwrt(0x07);
	lcd8_int();
	lcd8_int();
	lcd8_cmdwrt(0x08);
	lcd8_cmdwrt(0x05);
	lcd8_cmdwrt(0x05);
	lcd8_int();
}
/*******************************************************************************/
/*   Function Name : lcd8_cls(void)
/*   Disctiption   : 8Seg LCD ́@SNA
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_cls(void)
{
	unsigned int i;
	lcd8_int();
	lcd8_write(0xA0);
	for ( i = 0; i <16 ;i++)lcd8_write(0);
	lcd8_int();
}
/*******************************************************************************/
/*   Function Name : lcd8_put(unsigned int x,unsigned int y,unsigned int d)
/*   Disctiption   : 8Seg LCD wʒuɕ\@R[h͂P`PT܂
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_put(unsigned int x,unsigned int y,unsigned int d)
{
	lcd8_int();
	lcd8_write(0xA0 + x + (y*7));
	lcd8_write(segdat[d]);
	lcd8_int();
}
/*******************************************************************************/
/*   Function Name : lcd8_init(void)
/*   Disctiption   : 8Seg LCD CjVCY 
/*   Input         : 
/*   Output        : 
/*******************************************************************************/
void lcd8_init_old(void)
{	
	SLCD_RST=0;
	lcd8_int();
	lcd8_int();

	SLCD_DAT=1;
	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	lcd8_clk();

	lcd8_int();
	lcd8_int();

	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	lcd8_clk();

	lcd8_int();
	lcd8_int();

	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();

	lcd8_int();
	lcd8_int();

	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();
	SLCD_DAT=0;
	lcd8_clk();
	SLCD_DAT=1;
	lcd8_clk();

	lcd8_int();
}
